#include <stdlib.h>
#include "y.tab.h"
#include "table.h"
#include "outils.h"
#include "var.h"
#include "generateur.h"
#include "erreur.h"

extern int yylval;
extern int yyleng;
extern char *yytext;

/* #############################################################################
############################# Action  effectuer pour les lexmes ##############
##############################################################################*/

/* ********************* Action d'une fonction ***************************** */
int action_fun(void)
debut 
	 /* si le lexeme est trop important */	 
	  si (yyleng>=max_car)
	      debut
	       erreur_ligne();
	       fprintf(stderr,"Nom de fonctions trop long: %s\n",yytext);
	       exit(0);
	      fin
	 
	 /* on est dans la dfinition d'une fonction */
	  si (ds_quoi==0)
	   debut
	     /* on diffrencie une fonction du programme principal */
	     si (strcmp(yytext,"programme")==0)
	      debut
	       erreur_ligne();
	       fprintf(stderr,"Impossible de nommer la fonction 'programme'\n");
	       exit(0);
	      fin
	     strcpy(nom_fun_en_cours,yytext);
	     change_fun();
           fin
	  
	  /* dans le corp d'une fonction */
	  si ( (ds_quoi==2) || (ds_quoi==4) || (ds_quoi==5) )
	   debut
	    
	    /* on inderdit d'appeler la fonction principale */
	    si (strcmp(yytext,"programme")==0)
	      debut
	       erreur_ligne();
	       fprintf(stderr,"On n'apelle pas le programme principal'\n");
	       exit(0);
	      fin
	     
	     /* on interdit les appels rcursifs */
	    si (strcmp(yytext,nom_fun_en_cours)==0)
	     debut
	      erreur_ligne();
	      fprintf(stderr,"Appel rcursif interdit\n");
	      exit(0);
	     fin
	     strcpy(nom_fun_appel,yytext);
	   fin
fin



/* ********************* Action d'une variable ***************************** */
void action_var(void)
debut         

	 /* si le lexeme est trop important */
	 si (yyleng>=max_car)
	      debut
	       erreur_ligne();
	       fprintf(stderr,"Nom de Variable trop long: %s\n",yytext);
	       exit(0);
	      fin
	  /* dans chacun des cas, on applique la bonne fonction */
	  si (ds_quoi==2) yylval=cherche_adresse_var(yytext,nom_fun_en_cours);
	  si (ds_quoi==0) parametre_var(yytext,nom_fun_en_cours,0);
	  si (ds_quoi==1) creation_var(yytext,nom_fun_en_cours);
	  si (ds_quoi==6) creation_var_global(yytext);
	  si (ds_quoi==3) ajoute_en_param(yytext,nom_fun_appel,0);
	  si (ds_quoi==4) 
	   debut
	    asm_boucle(yytext,nom_fun_en_cours);
	    ds_quoi=2;
	   fin
	  si (ds_quoi==5)
	   debut
	    asm_hyper(yytext,nom_fun_en_cours);
	    ds_quoi=2;
	   fin
fin


/* ********************* Action d'un tableau ***************************** */
void action_tab(void)
debut
	 
	 /* si le lexeme est trop important */
	  si (yyleng>=max_car)
	      debut
	       erreur_ligne();
	       fprintf(stderr,"Nom de Tableau trop long: %s\n",yytext);
	       exit(0);
	      fin
	  /* dans chacun des cas, on applique la bonne fonction */
	  si (ds_quoi==2) yylval=cherche_adresse_tab(yytext,nom_fun_en_cours);	  
	  si (ds_quoi==0) 
	   debut
	    /*on interdit les parametres de tableaux au programme principales */
	    si (prog_ou_non)
	     debut
	      erreur_ligne();
	      fprintf(stderr,"Ne mettez pas de tableaux en parametres au programme principale\n");
	      exit(0);
	     fin
	      parametre_var(yytext,nom_fun_en_cours,1);
	    fin
	  si ( (ds_quoi==1) || (ds_quoi==6)) strcpy(nom_tablo_en_cours,yytext);
	  si (ds_quoi==3) ajoute_en_param(yytext,nom_fun_appel,1);
fin



/* ********************* Action d'un nombre ***************************** */
void action_nb(void)
debut
	  yylval=atoi(yytext);

	  /* si la valeur est < 0, on manipule que des nombres positifs */
	  si (yylval<0)
	   debut
	    erreur_ligne();
	    fprintf(stderr,"Pas de nombre<0\n");
	    exit(0);
	   fin
	  
	  /* Si la taille du nombre est trop importante */
	  si (yyleng>20)
	   debut
	    erreur_ligne();
	    fprintf(stderr,"Nombre trop grand\n");
	    exit(0);
	   fin
	  
	  /* si on va entrer dans un tableau */
	  si ((ds_quoi==1) || (ds_quoi==6)) 
	   debut
	    taille=yylval;
	    if (taille==0)
	     debut
	      erreur_ligne();
	      fprintf(stderr,"Pas de tableau de dimension nul\n");
	      exit(0);
	     fin
	   fin
	  si (ds_quoi==5) pile_hyper[nb_hyper].nb_push_hyper=yylval;
fin


/* ********************* Action de "creation" ***************************** */
void action_creation(void)
debut
	if ((ds_quoi!=0) && (ds_quoi!=6))
	   debut
	    erreur_ligne();	   
	    fprintf(stderr,"Veuillez mettre vos cration de variables globales en tete de vos fichiers\n");
	    exit(0);
	   fin
          if (ds_quoi==0) 
             debut 
	       ds_quoi=1;
	       /* Poper(nom_fun_en_cours); */
	     fin
fin


/* ********************* Action de "programme" ***************************** */
void action_programme(void)
debut
 ds_quoi=0;
 ligne_debut_prog=ligne_asm;
 strcpy(nom_fun_en_cours,yytext);
 mettre_programme();
fin


/* ********************* Action de "(" ***************************** */
void action_ouv(void)
debut
 si (ds_quoi==2) 
       debut
         ds_quoi=3;
         nb_parametre=0;
	fin
fin


/* ********************* Action de ")" ***************************** */
void action_ferm(void)
debut
 si (ds_quoi==3) ds_quoi=2;
fin


/* ********************* Action de "]" ***************************** */
void action_croch_ferm(void)
debut
     /* on a fini le Tab[...] donc on change d'tats */
     si (ds_quoi==1) creation_tab(nom_tablo_en_cours,nom_fun_en_cours,taille);
     si (ds_quoi==6) creation_tab_global(nom_tablo_en_cours,taille);
fin


/* ********************* Action du reste ***************************** */
void action_reste(void)
debut
    erreur_ligne();
    fprintf(stderr,"Caractere inconnue\n");
    exit(0);
fin
