#include <stdio.h>
#include "var.h"
#include "generateur.h"
#include "erreur.h"
#include "outils.h"
#include "table.h"
#include "gene_tools.h"
#include "outils_asm.h"

/* ##############################################################################
############################# GENERATEUR DE CODE ###############################
################################################################################*/


/* ########################### Simple mov ###################################### */
/* ########################### variable:= ????, ????=var ou nombre suivant le mode ###### */
int mov(int val1,int val2,int mode)
debut
 si (mode==1) /* val1 est une variable et val2 est un nombre */
  debut
   add_instr(MOV,val1,0,val2,1);
  fin
 else
 si (mode==0) /* val1 est une variable et val2 est une variable */
  debut
   add_instr(MOV,val1,0,val2,0);
  fin
fin

/* ###################### mov avec une tableau ############################### */
int mov_tab(int val1,int val2,int val3,int mode)
debut
 int tmp;
 
 /* ****************** Tablo[nombre]:=???? ********************** */
 si ((mode==0) || (mode==2))
  debut
      add_instr(MOV,0,0,val2,1);
      add_instr(MOD,0,0,val1+1,0);
      add_instr(ADD,0,0,val1,0);
      
       /* val1<=>tablo val2<=>nombre val3<=>ident, Tab[nb]=id */
      si (mode==0)
        add_instr(MOV,0,2,val3,0);
	
	/*val1<=>tablo val2<=>nombre val3<=>nombre */
       else
        add_instr(MOV,0,2,val3,1);
  fin
 else
  /* *************************** ident:=Tablo[???]****************** */
  si ((mode==4) || (mode==5)) 
  debut
      
       /*val1<=>ident val2<=>tablo val3<=>nombre */
      si (mode==4)
          add_instr(MOV,0,0,val3,1); 
       else  /*val1<=>ident val2<=>tablo val3<=>ident */
         add_instr(MOV,0,0,val3,0);
      
      add_instr(MOD,0,0,val2+1,0);
      add_instr(ADD,0,0,val2,0);
      add_instr(MOV,val1,0,0,2);
  fin
 else
  debut
	add_instr(MOV,0,0,val2,0); 
	add_instr(MOD,0,0,val1+1,0);
	add_instr(ADD,0,0,val1,0);
	/*val1<=>tablo val2<=>ident val3<=>ident */ 
	si ( (mode==1) || (mode==6))
	 add_instr(MOV,0,2,val3,0); 
	/*val1<=>tablo val2<=>ident val3<=>nombre */
	si (mode==3) 
	 add_instr(MOV,0,2,val3,1);
  fin  
fin

/* ########################## Generation de A:=A+nb ########################### */
int inc(int val1,int val2,int comb)
debut

 /* *************** Si on n'a pas A:=A alors ce n'est pas bon ********* */
 si (val1==val2) 
  add_instr(ADD,val1,0,comb,1);
  else 
   debut
    erreur_ligne();
    fprintf(stderr,"Pour cette instruction, il faut la meme variable\n");
    exit(0);
   fin
fin

/* ############################# A:=A-nb #####################################*/
int dec(int val1,int val2,int comb)
debut

 /* *************** Si on n'a pas A:=A alors ce n'est pas bon ********* */
 si (val1==val2)
  add_instr(SUB,val1,0,comb,1);
  else    
   debut
    erreur_ligne();
    fprintf(stderr,"Pour cette instruction, il faut la meme variable\n");
    exit(0);
   fin
fin

/* ##############################################################################
############################# A:=fun(...) #####################################
################################################################################*/
int mov_fun_id(int val1)
debut
 int adr,j,nb;
 bool test;

 /* ********* on recherche l'indice de la fonction dans la table des symboles */
 adr=recherche_fonction(nom_fun_appel);
 
 /* **************** On test les arguments ******************************* */
 test=bon_argument(adr);
 si (!test)
  debut
    erreur_ligne();
    fprintf(stderr,"Nombre d'arguments errone\n");
    exit(0);
  fin
 
 /* *************************************************************************** */
 /* **************** cas des fonctions prdfinies **************************** */

 /* ************************* LIRE ***************************************** */
 si (strcmp(nom_fun_appel,"lire")==0) 
  debut
    add_instr(INT,1,0,0,0);
    add_instr(MOV,val1,0,0,0);
  fin
  else
 
 /* ***************************** ECRIRE ************************************** */
 si (strcmp(nom_fun_appel,"ecrire")==0)
  debut
   add_instr(MOV,1,0,parametre_en_cour[0].adresse,0);
   add_instr(INT,2,0,0,0);
   add_instr(MOV,val1,0,0,1);
  fin
  else

 /* *************************** OUVREGRAPH *************************************** */
 si (strcmp(nom_fun_appel,"ouvregraph")==0)
  debut
   add_instr(INT,3,0,0,0);
   add_instr(MOV,val1,0,0,1);
  fin
  else

 /* ***************************** FERMEGRAPH ************************************ */
 si (strcmp(nom_fun_appel,"fermegraph")==0)
  debut
    add_instr(INT,4,0,0,0);
    add_instr(MOV,val1,0,0,1);
  fin
  else
  
 /* ******************************* EFFACE **************************************** */
 si (strcmp(nom_fun_appel,"efface")==0)
  debut
   add_instr(INT,5,0,0,0);
   add_instr(MOV,val1,0,0,1);
  fin
  else
  
 /* ******************************** PIXEL ************************************* */
 si (strcmp(nom_fun_appel,"pixel")==0)
  debut
   add_instr(MOV,1,0,parametre_en_cour[0].adresse,0);
   add_instr(MOV,2,0,parametre_en_cour[1].adresse,0);
   add_instr(MOV,3,0,parametre_en_cour[2].adresse,0);
   add_instr(INT,6,0,0,0);
   add_instr(MOV,val1,0,0,1);
  fin
 else

 /* ****************************** QUITTER ************************************* */
 si (strcmp(nom_fun_appel,"quitter")==0) add_instr(END,0,0,0,0);
 else
 
 /* ************************ SORTIR ******************************************** */
 si (strcmp(nom_fun_appel,"sortir")==0)
  debut
   /*si (nb_hyper!=0) /* *************** Pas de sortir dans une hyperboucle ******** */
     /*debut
      erreur_ligne();
      fprintf(stderr,"Il est interdit d'utiliser un 'sortir' dans une hyperboucle\n");
      exit(0);
     fin */
    add_instr(MOV,val1,0,0,1);
    add_instr(JNZ,parametre_en_cour[0].adresse,0,0,0);
    add_sortir(); /* mettre le code spcifique de sortir */
  fin
 else
 
 /* *************************** RETOURNER ********************************* */
 si (strcmp(nom_fun_appel,"retourner")==0)
  debut
   si (nb_hyper!=0) /* on interdit les retourner dans les hyperboucles */
        debut
         erreur_ligne();
         fprintf(stderr,"Il est interdit d'utiliser un 'retourner' dans une hyperboucle en dehors du programme principal\n");
         exit(0);
        fin
   else 
      /* Si on est dans le programme principal, il suffit de quitter */   
    si (prog_ou_non) add_instr(END,0,0,0,0);   
     else 
      
      /* Sinon on gnre le code,voir rapport */
      debut
        add_instr(MOV,val1,0,0,1);
        add_instr(POP,0,0,0,0);
        add_instr(PUSH,parametre_en_cour[0].adresse,0,0,0);
        add_instr(JMP,0,0,0,0);
      fin
 fin   
 else
 
 /* ***************** ENFONCER, voir rapport ********************** */
  si (strcmp(nom_fun_appel,"enfoncer")==0)
   debut
     si (nb_hyper==0) /* on interdit les enfoncer en dehors des hyperboucles */
      debut
       erreur_ligne();
       fprintf(stderr,"Il est interdit d'utiliser un 'enfoncer' en dehors d'une hyperboucle\n");
       exit(0);
      fin
     add_instr(MOV,val1,0,0,1);
     nb=pushe_var(); /* on push les variables de la fonction */
     add_enfonce();  /* on met le code de l'enfonce */
   fin
 else
 
     /* ************ fonction de l'utilisateur *************** */
     debut
       /* on push l'adresse de code qui suit les instructions d'appel de la fonction */
       add_instr(PUSH,ligne_asm+2+combien_de_push(),1,0,0);
       /* on push les variables en parametres */
       pusher();
       /* on saute a l'adresse de la fonction */
       add_instr(JMP,table[adr].adresse,1,0,0);
       /* on rcupre la rsultats */
       add_instr(POP,val1,0,0,0);
     fin
fin


/* ############################### POPER #######################################
   On POP les parametres en dbut de fonction pour recuperer les variables */ 
void Poper(char *name_fun)
debut
 int j,i;
  j=nb_fun_lu-1;
  
  /* On pop en sens inverse des push donc de la fin vers le dbut */
  pour(i=table[j].nb_param-1;i>=0;i--)
   debut
   
    /* Si variable un simple pop */
    si (table[j].table_param[i].type==0)
     debut
      add_instr(POP,table[j].table_param[i].adresse,0,0,0);
      fin
    else
    
    /* Si tableau, on pop la taille puis l'adresse */
     debut
       add_instr(POP,table[j].table_param[i].adresse+1,0,0,0);
       add_instr(POP,table[j].table_param[i].adresse,0,0,0);
     fin
   fin
fin


/* ###################### Le code de sortir ################################### */
void add_sortir(void)
debut

 /* Si on creer trop de sortir, on sature la mmoire */
 si (pile_boucle[nb_boucle-1].nb_sort==max_sort)
  debut
    erreur_ligne();
    fprintf(stderr,"Plus assez de mmoire pour ce sortir\n");
    exit(0);
  fin
  
 /* on mmorise l'adresse de "sortir" pour plus tard */
 pile_boucle[nb_boucle-1].sort[pile_boucle[nb_boucle-1].nb_sort]=ligne_asm-1;
 
 /* on augmente le nombre de "sortir" */
 pile_boucle[nb_boucle-1].nb_sort++;

fin


/* ########################## On push les variables pour les hyperboucles ########## */
int pushe_var(void)
debut
 int i,j,nb;
 j=nb_fun_lu-1;

 /* TOUS LES PARAMETRES */ 
 pour(i=0;i<table[j].nb_param;i++)
  /* si ce sont des variables bien entendu */
  si (table[j].table_param[i].type==0) 
   debut 
    add_instr(PUSH,table[j].table_param[i].adresse,0,0,0);
    nb++;
   fin
 
 /* TOUTES les variables de cration */
 pour(i=0;i<table[j].nb_var;i++)
  debut
   add_instr(PUSH,table[j].table_var[i].adresse,0,0,0);
   nb++;
  fin
 
 /*TOUTES les variables indiquer par enfonce(A)*/
 pour(i=0;i<pile_hyper[nb_hyper-1].nb_push_hyper;i++)
  debut
   add_instr(PUSH,pile_hyper[nb_hyper-1].adr_tmp+i+1,0,0,0);
   nb++;
  fin
 /* on retourne le nombre de push ainsi effectuer */
 retourne nb;
fin


/* ########################## On pop les variables pour les hyperboucles ########## */
int pop_var(void)
debut
 int i,j,nb;
 
   j=nb_fun_lu-1;
  /* TOUTES les variables tempporaires des boucles...*/
  pour(i=pile_hyper[nb_hyper-1].nb_tmp-1;i>=0;i--)
  debut
   add_instr(POP,pile_hyper[nb_hyper-1].adr_env[i],0,0,0);
   nb++;
  fin


 /* TOUTES les variables de cration */ 
 pour(i=table[j].nb_var-1;i>=0;i--)
  debut
   add_instr(POP,table[j].table_var[i].adresse,0,0,0);
   nb++;
  fin

 /* TOUS LES PARAMETRES */ 
 pour(i=table[j].nb_param-1;i>=0;i--)
   /* si ce sont des variables bien entendu */
  si (table[j].table_param[i].type==0) 
   debut 
    add_instr(POP,table[j].table_param[i].adresse,0,0,0);
    nb++;
   fin
 
 /* on retourne le nombre de pop ainsi effectuer */
 retourne nb;
fin

/* ##################### LE code spcifique d'un enfonce ######################## */
void add_enfonce(void)
debut

 /* si on demande trop d'enfonce, on quitte */
 si (pile_hyper[nb_hyper-1].nb_enfonce==max_enfonce)
  debut
   erreur_ligne();
   fprintf(stderr,"Trop de 'enfoncer'  la suite, esssayer une hyperboucle imbrique\n");
   exit(0);
  fin

 add_instr(PUSH,ligne_asm+4,1,0,0);
 add_instr(SUB,pile_hyper[nb_hyper-1].adr_compt,0,1,1);
 add_instr(JZ,pile_hyper[nb_hyper-1].adr_compt,0,0,0);
 
 /* on mmorise l'adresse de cette enfonce */
 pile_hyper[nb_hyper-1].enfonce[pile_hyper[nb_hyper-1].nb_enfonce]=ligne_asm-1;
 
 /* on augmente le nombre d'enfonce de l'hyperboucle */
 pile_hyper[nb_hyper-1].nb_enfonce++;
 add_instr(JMP,pile_hyper[nb_hyper-1].adr_debut,1,0,0);
fin



/* ############################### Code de fin de fonction ####################### */
void fin_fun()
debut
 int i;
  
 /* si on est dans le programme principal, on met "end" */
 si (prog_ou_non) add_instr(END,0,0,0,0);
  else
    /* on fait un retour de 0 et on suate aux dernier appel */
   debut
     add_instr(POP,0,0,0,0);
     add_instr(PUSH,0,1,0,0);
     add_instr(JMP,0,0,0,0);
   fin
   
 /* On copie toutes les instructions sur le fichier */
 pour(i=0;i<nb_instr;i++) 
   debut
     aff_instr(bloc_instr[i],ligne_asm-(nb_instr-i));
   fin
   
 /* on remet a jours */
 nb_instr=0;
 nb_boucle=0;
 nb_hyper=0; 
fin

/* ######################### Code de debut de boucle ############################# */
int asm_boucle(char *name,char *name_fun)
debut
 int x,adr;
 
 /* Si on fait trop de boucle dans une fonction, on sature la mmoire */
 si (nb_boucle==max_boucle)
  debut
   erreur_ligne();
   fprintf(stderr,"Trop de boucles, utiliser plutot une Hyperboucle\n");
   exit(0);
  fin
 
 /* on prend une case mmoire pour le compteur */
 x=cherche_case();
 si (x==-1)
  debut
    erreur_ligne();
    fprintf(stderr,"Pas assez de mmoire pour la boucle avec la variable:%s\n",name);
    exit(0);
  fin
 
 /* on recherche l'adresse de A pour "boucle A fois" */
 adr=cherche_adresse_var(name,name_fun);
 
 /* on met la valeur de "A" dans le compteur */
 add_instr(MOV,x,0,adr,0);

 /* On met a jour les donnes de la boucle, c'est  dire l'adresse du code du jz, sa valeur
  le nombre de "sortir" est mis  0 et on augmente le nombre de boucle */
 pile_boucle[nb_boucle].adr_jz=ligne_asm;
 pile_boucle[nb_boucle].val_jz=x;
 pile_boucle[nb_boucle].nb_sort=0;
 nb_boucle++;
 
 /* on place l'instrcution */
 add_instr(JZ,0,1,0,0);
fin


/* ######################### Code de debut de hyperboucle ############################# */
int asm_hyper(char *name,char *name_fun)
debut
 int x,y,z,adr;

 /* Si on a trop de hyperboucle dans une fonction */
 si (nb_hyper==max_hyper)
  debut
   erreur_ligne();
   fprintf(stderr,"Trop de hyperboucle pour moi, dsolez.\n");
   exit(0);
  fin
 
 /* on prend une case pour le compteur, voir rapport */
 x=cherche_case();
 si (x==-1)
  debut
    erreur_ligne();
    fprintf(stderr,"Pas assez de mmoire pour l'hyperboucle avec la variable:%s\n",name);
    exit(0);
  fin 
 
 /* on prend une case pour le compteur de max */
 y=cherche_case();
 si (y==-1)
  debut
    erreur_ligne();
    fprintf(stderr,"Pas assez de mmoire pour l'hyperboucle avec la variable:%s\n",name);
    exit(0);
  fin 

/*on prend une case pour le temporaire de final */
 z=cherche_case();
 si (y==-1)
  debut
    erreur_ligne();
    fprintf(stderr,"Pas assez de mmoire pour l'hyperboucle avec la variable:%s\n",name);
    exit(0);
  fin 

/* on recherche l'adresse de A dans "hyperboucle A fois " */
 adr=cherche_adresse_var(name,name_fun);
 
 /* faire le code, voir rapport */
 add_instr(JZ,adr,0,0,0);
 pile_hyper[nb_hyper].adr_test=ligne_asm-1;
 add_instr(MOV,x,0,adr,0);
 add_instr(ADD,adr,0,1,1);
 add_instr(MOV,y,0,adr,0);
 add_instr(SUB,adr,0,1,1);
 
 /* on met a jour la table, en mettant le valeur de compteur,de max, de tmp
    l'adresse debut de j'hyprtboucle */
 pile_hyper[nb_hyper].adr_compt=x;
 pile_hyper[nb_hyper].adr_max=y;
 pile_hyper[nb_hyper].adr_tmp=z;
 pile_hyper[nb_hyper].nb_enfonce=0;
 pile_hyper[nb_hyper].adr_debut=ligne_asm; 
 pile_hyper[nb_hyper].nb_tmp=0;
 
 /* on augmente le nombre d'hyperboucle */
 nb_hyper++;
fin

/* ########################### Code de fin de boucle ########################## */
int fin_boucle(void)
debut
 int i;
 
 /* on decremente le compteur et on saute */
 add_instr(SUB,pile_boucle[nb_boucle-1].val_jz,0,1,1);
 add_instr(JMP,pile_boucle[nb_boucle-1].adr_jz,1,0,0);
 
 /* on met l'sintruction de saut de debit de boucle a jour (JZ) */
 bloc_instr[pile_boucle[nb_boucle-1].adr_jz-ligne_asm+nb_instr].adr2=ligne_asm;
 bloc_instr[pile_boucle[nb_boucle-1].adr_jz-ligne_asm+nb_instr].type2=1;
 bloc_instr[pile_boucle[nb_boucle-1].adr_jz-ligne_asm+nb_instr].adr1=pile_boucle[nb_boucle-1].val_jz;
 bloc_instr[pile_boucle[nb_boucle-1].adr_jz-ligne_asm+nb_instr].type1=0;
 
 /* printf("------- %d %d %d\n",pile_boucle[nb_boucle-1].nb_sort,ligne_asm,pile_boucle[nb_boucle-1].sort[0]); */
 /* On remet a jours tous les "sortir" */
 for(i=0;i<pile_boucle[nb_boucle-1].nb_sort;i++)
 debut
   bloc_instr[pile_boucle[nb_boucle-1].sort[i]-ligne_asm+nb_instr].adr2=ligne_asm;
   bloc_instr[pile_boucle[nb_boucle-1].sort[i]-ligne_asm+nb_instr].type2=1;
 fin
 nb_boucle--;
fin


/* ########################### Code de fin de hyper avant le final ############## */
int fin_hyper(void)
debut
 
 /* on met le bon code */
 add_instr(ADD,pile_hyper[nb_hyper-1].adr_compt,0,1,1);
 add_instr(JE,pile_hyper[nb_hyper-1].adr_max,0,pile_hyper[nb_hyper-1].adr_compt,0);
 add_instr(JZ,pile_hyper[nb_hyper-1].adr_max,0,0,0);

 /* on met a jour l'adresse de fin de hyper */
 pile_hyper[nb_hyper-1].adr_je=ligne_asm-1;
 add_instr(POP,pile_hyper[nb_hyper-1].adr_tmp,0,0,0);
 
 /* on reprend les anciennes valeur, c'est  dire le contexte */
 pop_var();
 add_instr(JMP,pile_hyper[nb_hyper-1].adr_tmp,0,0,0);
 pile_hyper[nb_hyper-1].adr_final=ligne_asm;
fin

/* ####################### Code du final ################################ */
int fin_final(void)
debut
 int i;
 
 /* on met les instructions ncessaire */
 add_instr(ADD,pile_hyper[nb_hyper-1].adr_compt,0,1,1);
 add_instr(POP,pile_hyper[nb_hyper-1].adr_tmp,0,0,0);
 
 /* on restaure le contexte */
 pop_var();
 add_instr(JMP,pile_hyper[nb_hyper-1].adr_tmp,0,0,0);

 /* mettre bien le test et le JE */ 
 bloc_instr[pile_hyper[nb_hyper-1].adr_je-ligne_asm+nb_instr].adr2=ligne_asm;
 bloc_instr[pile_hyper[nb_hyper-1].adr_je-ligne_asm+nb_instr].type2=1;
 
 bloc_instr[pile_hyper[nb_hyper-1].adr_test-ligne_asm+nb_instr].adr2=ligne_asm;
 bloc_instr[pile_hyper[nb_hyper-1].adr_test-ligne_asm+nb_instr].type2=1;

 
 /* on remet tous les enfonces */
 for(i=0;i<pile_hyper[nb_hyper-1].nb_enfonce;i++)
  debut
   bloc_instr[pile_hyper[nb_hyper-1].enfonce[i]-ligne_asm+nb_instr].adr2=pile_hyper[nb_hyper-1].adr_final;
   bloc_instr[pile_hyper[nb_hyper-1].enfonce[i]-ligne_asm+nb_instr].type2=1;
  fin
  
 /* on dcremente le nombre de hyper */
 nb_hyper--;
fin
