#include <X11/Xlib.h>
#include <stdio.h>
#include "graph.h"

bool ouvert;
bool GRAPHIC;

Window win;
int ecran;
GC gcontext,gcontextClear;
Display *dpy;
XColor coul;
Colormap cmap;
XGCValues gcv;
Status status;

/* ###########################"" creation de la fenetre ######################" */
void creation_fenetre(void)
{
 Window root;
 
 dpy=XOpenDisplay(NULL);  /* ouverture du mode display */
 if (dpy==NULL)
  {
   fprintf(stderr,"pas de mode graphique possible\n");
   perror("XOpenDisplay");
   GRAPHIC=faux;
   return;
  }
  
 GRAPHIC=vrai;
 ecran=DefaultScreen(dpy); /* ouverture de l'ecran */
 root=DefaultRootWindow(dpy); /* la fenetre root */
 cmap=XDefaultColormap(dpy,ecran); /* creation de la Colormap */

 /* Creation de la fenetre, on lui donne un nom, un curseur */
 win=XCreateSimpleWindow(dpy,root,1,1,LARGEUR,HAUTEUR,8,BlackPixel(dpy,ecran),BlackPixel(dpy,ecran));
 XStoreName(dpy,win,"LAB Graphique, version 1");
 XSelectInput(dpy,win,NoEventMask);
}

/* ###################### definition de la couleur pour le contexte ######## */
void definir_couleur(void)
{
 if (GRAPHIC)
  {
  unsigned long gcmask;
  gcv.foreground=coul.pixel;
  gcv.background=WhitePixel(dpy,ecran);;
  gcv.line_width=2;
  gcmask=GCForeground | GCBackground| GCLineWidth;
  gcontext=XCreateGC(dpy,win,gcmask,&gcv);
 }
}

/* ##################"" initialisation du contexte dessin et de Clear ########## */
void initialiser_contexte(void)
{
 if (GRAPHIC)
  {
   unsigned long gcmask;

   coul.pixel=0;
   coul.flags=DoRed | DoBlue | DoGreen;
   coul.red=0;
   coul.green=0;
   coul.blue=0;
   // status=XAllocColor(dpy,cmap,&coul1); A rajouter mais ne marche pas ???

   gcmask=GCForeground | GCBackground | GCLineWidth | GCFunction;
   gcontextClear=XCreateGC(dpy,win,gcmask,&gcv);
  }
}

/* ##################### procedure qui ouvre le mode graphique ############### */
void ouvre_graph(void)
{
 if (!ouvert && GRAPHIC) 
  {
   XMapWindow(dpy,win);
   status=XAllocColor(dpy,cmap,&coul);
   ouvert=vrai;
  }
}

/* ######################  procedure qui ferme le mode graphique ###############*/
void ferme_graph(void)
{
 if (ouvert && GRAPHIC) 
  {
   XUnmapWindow(dpy,win);
   status=XAllocColor(dpy,cmap,&coul);
   ouvert=faux;
   }
}

/* ##################  procedure qui efface l'ecran ############################*/
void clear_graph(void)
{
 if (ouvert && GRAPHIC)
  {
   XFillRectangle(dpy,win,gcontextClear,0,0,LARGEUR,HAUTEUR);
   status=XAllocColor(dpy,cmap,&coul);
   // Pourqoui il ne marche pas ???? XClearWindow(dpy,win);
  }
}

/* ##################### Creation du mode graphique ########################### */
void mode_graphique(void)
{
 creation_fenetre();
 initialiser_contexte();
 definir_couleur();
}

/* ####################  Destruction du mode graphique  ########################*/
void fin_mode_graphique(void)
{
  if (GRAPHIC) XCloseDisplay(dpy); 
}

/* #######################  placer un point  ################################## */
void placer_point(int x,int y,int color)
{
 if (ouvert && GRAPHIC)
  {
   coul.pixel=color % max_couleur;
   coul.flags=DoRed | DoBlue | DoGreen;
   coul.red=0;
   coul.green=0;
   coul.blue=0;
   definir_couleur();
   status=XAllocColor(dpy,cmap,&coul);
   XDrawPoint(dpy,win,gcontext,x % LARGEUR,y % HAUTEUR);
  }
}
