%{
#include <stdlib.h>
#include "y.tab.h"
#include "table.h"
#include "outils.h"
#include "var.h"
#include "generateur.h"
#include "erreur.h"
#include "action_lex.h"
extern int yylval;
%}

blancs [ \t]+
saut [\n]
chiffre   [0-9]
nombre    {chiffre}+
lettremaj [A-Z]
lettremin [a-z]
id_fun {lettremin}+{chiffre}*
id_var {lettremaj}+{chiffre}*
id_tab {lettremaj}{lettremin}+{chiffre}*
%%
{blancs} ;
{saut}        {ligne++;}          /* un saut, donc on augmente le nombre de ligne */
#.* ;                             /* Commentaire Simple d'une seul ligne*/
"/*"          commentaire=vrai; /* Debut d'un gros commentaire */
"*/"          commentaire=faux; /* fin d'un gros commentaire */
"debut"       if (!commentaire) {ds_quoi=2;Poper(nom_fun_en_cours);return(DEBUT);}
"fin"         if (!commentaire) return(FIN);
"creation"    if (!commentaire) {action_creation();return(CREATION);}
"entier"      if (!commentaire) {ds_quoi=0;return(ENTIER);}
"boucle"      if (!commentaire) {ds_quoi=4;return(BOUCLE);}
"fois"        if (!commentaire) return(FOIS);
"hyperboucle" if (!commentaire) {ds_quoi=5;return(HYPERBOUCLE);}
"final"       if (!commentaire) return(FINAL);
"programme"   if (!commentaire) {action_programme();return(PROGRAMME);}

{id_fun} if (!commentaire) {action_fun();return(NOM_FONCTION);}
{id_var} if (!commentaire) {action_var();return(IDENTIFIANT);}
{id_tab} if (!commentaire) {action_tab();return (TABLO);}

"+" if (!commentaire) return(PLUS);
"-" if (!commentaire) return(MOINS);
"=" if (!commentaire) return(EGALE);
"(" if (!commentaire) {action_ouv();return(PARENT_OUV);}
")" if (!commentaire) {action_ferm();return(PARENT_FERM);}
"[" if (!commentaire) return(CROCH_OUV);
"]" if (!commentaire) {action_croch_ferm();return(CROCH_FERM);}
":" if (!commentaire) return(DEUX_POINTS);
";" if (!commentaire) return(POINT_VIR);
"," if (!commentaire) return(VIRGULE);

{nombre} if (!commentaire) {action_nb();return(NOMBRE);}

. if (!commentaire) {action_reste();}
%%

/* ***************  La fonction pour relancer l'analyse des fichiers ********** */
int yywrap(void)
{
 if (nb_fichier==nb_arg) return 1;
 
 yyin=fopen(argument[nb_fichier++],"r");
 if (yyin==NULL)
  {
    perror("fopen");
    fprintf(stderr,"Impossible de lire: %s\n",argument[nb_fichier-1]);
    exit(0);
  }
  
 ds_quoi=6;
 ligne=1;
 return 0;
}
