#ifndef OUTILS_H

#define OUTILS_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdarg.h>
#include <errno.h>
#include <sys/types.h>


/* Definition des tests d'erreurs relativement graves */
#define EXIT_FAILURE 1 /* Pour les exit d'erreur */


/* Definition d'une macro de debuggage */
#define __d {fprintf(stderr,"%d04, %s\n",__LINE__,__FILE__);fflush(stderr);}

#define __f {fprintf(stderr,"la\n");fflush(stderr);}

/* Definition d'une macro pour les problmes d'allocations de mmoires.
Si la mmoire est insuffisantes il faut stopper le programme */
#define Erreur_memoire(n,nom,fonct) if (n==NULL) { fprintf(stderr,"Erreur de memoire pour %s dans %s erreur:%d\n",nom,fonct,errno);perror("malloc");exit(EXIT_FAILURE); }

/* pour avoir une ressemblance avec un algo */
#define debut {
#define fin }
#define entier int
#define retourne return
#define si if
#define sinon else
#define tantque while
#define pour for

/* Pour facilite la lecture */
typedef enum {faux,vrai} bool;

/* Definition des piles d'entier */
typedef struct Pile
 {
  int nb_elemt;
  int *tab_pile;
 } pile;

/* Definir le nombre maximal de caracatere d'une variable ou d'une fonction
etc..., 50 */
#define max_car 50 

bool Estpilevide(pile p); /* test si la pile est vide ou non */
pile Push(pile p,int elem); /* empiler un entier */
pile Pop(pile p,int *elem); /* dpiler un entier */

#endif
