#include <stdio.h>
#include "outils.h"
#include "outils_asm.h"
#include "outils.h"
#include "erreur.h"
#include "var.h"

/* ############################################################################
######################## Gestion des instruction: 
 			      ecriture,cration,inclusion #####################
############################################################################### */

/* ################ Cration d'une instruction  l'aide des arguments ######### */
instruction make_instr(typeinstr instr,entier adr1,entier type1,entier adr2,entier type2)
debut
 instruction ins;
  ins.instr=instr;
  ins.adr1=adr1;
  ins.type1=type1;
  ins.adr2=adr2;
  ins.type2=type2;
  retourne ins;
fin

/* ################ Ajout d'une instruction dans le code (par bloc)
          on augment le nombre de ligne d'assembleur et le nombre d'instruction generer */
void add_instr(typeinstr instr,entier adr1,entier type1,entier adr2,entier type2)
debut
 instruction ins;
 /* ************* Si trop d'instruction ******************** */
 si (nb_instr==max_instr)
  debut
   erreur_ligne();
   fprintf(stderr,"Trop d'instruction machine generer pour cette fonction.Veuiller la diviser\n");
   exit(0);
  fin
 
 /* *********** Cration de l'instruction ********************** */
 ins=make_instr(instr,adr1,type1,adr2,type2);

 /* *********** Ajout de l'instruction ************************* */
 bloc_instr[nb_instr]=ins;
 
 /* ************* On augmente le nombre de ligne et d'instruction gnr **** */
 nb_instr++;
 ligne_asm++;
fin

/* ####### ecrit une composante d'une instruction ########### */
void aff_comp(entier adr,entier type)
debut
 switch (type)
 {
  case 0:fprintf(file_asm," %d",adr);break;
  case 1:fprintf(file_asm," #%d",adr);break;
  case 2:fprintf(file_asm," @%d",adr);break;
  default:fprintf(stderr,"Erreur interne  labc\n");exit(0);
 }
fin

/* ################# Ecrit: - sur le fichier_asm l'instruction demande
			    - sur le fichier_exe     "         "       ####### */
void aff_instr(instruction ins,int i)
debut
 int test;

/* ************ Suivant le type de l'instruction *************** */
switch (ins.instr)
 {
  case PUSH:fprintf(file_asm,"%d: push",i);aff_comp(ins.adr1,ins.type1);fprintf(file_asm,"\n");break;
  case POP:fprintf(file_asm,"%d: pop",i);aff_comp(ins.adr1,ins.type1);fprintf(file_asm,"\n");break;
  case ADD:fprintf(file_asm,"%d: add",i);aff_comp(ins.adr1,ins.type1);aff_comp(ins.adr2,ins.type2);fprintf(file_asm,"\n");break;
  case SUB:fprintf(file_asm,"%d: sub",i);aff_comp(ins.adr1,ins.type1);aff_comp(ins.adr2,ins.type2);fprintf(file_asm,"\n");break;
  case MOV:fprintf(file_asm,"%d: mov",i);aff_comp(ins.adr1,ins.type1);aff_comp(ins.adr2,ins.type2);fprintf(file_asm,"\n");break;
  case MOD:fprintf(file_asm,"%d: mod",i);aff_comp(ins.adr1,ins.type1);aff_comp(ins.adr2,ins.type2);fprintf(file_asm,"\n");break;
  case ORG:fprintf(file_asm,"%d: org",i);aff_comp(ins.adr1,ins.type1);break;
  case END:fprintf(file_asm,"%d: end",i);fprintf(file_asm,"\n");break;
  case INT:fprintf(file_asm,"%d: int",i);aff_comp(ins.adr1,ins.type1);fprintf(file_asm,"\n");break;
  case JMP:fprintf(file_asm,"%d: jmp",i);aff_comp(ins.adr1,ins.type1);fprintf(file_asm,"\n");break;
  case JZ:fprintf(file_asm,"%d: jz",i);aff_comp(ins.adr1,ins.type1);aff_comp(ins.adr2,ins.type2);fprintf(file_asm,"\n");break;
  case JNZ:fprintf(file_asm,"%d: jnz",i);aff_comp(ins.adr1,ins.type1);aff_comp(ins.adr2,ins.type2);fprintf(file_asm,"\n");break;
  case JE:fprintf(file_asm,"%d: je",i);aff_comp(ins.adr1,ins.type1);aff_comp(ins.adr2,ins.type2);fprintf(file_asm,"\n");break;
  default:fprintf(stderr,"Erreur interne  labc\n");exit(0);
 }

/* ************* Ecriture dans le fichier exe *********************** */
 test=fwrite(&ins,sizeof(instruction),1,file_exe);
 si (!test)
  debut
   perror("fwrite");
   fprintf(stderr," Erreur d'criture sur le fichier exe\n");
   exit(0);
  fin
fin


void print_comp(entier adr,entier type)
debut
 switch (type)
 {
  case 0:fprintf(stdout," %d",adr);break;
  case 1:fprintf(stdout," #%d",adr);break;
  case 2:fprintf(stdout," @%d",adr);break;
  default:fprintf(stderr,"Erreur interne  labc\n");exit(0);
 }
fin


void print_instr(instruction ins)
debut
switch (ins.instr)
 {
  case PUSH:fprintf(stdout,"push");print_comp(ins.adr1,ins.type1);fprintf(stdout,"\n");break;
  case POP:fprintf(stdout,"pop");print_comp(ins.adr1,ins.type1);fprintf(stdout,"\n");break;
  case ADD:fprintf(stdout,"add");print_comp(ins.adr1,ins.type1);print_comp(ins.adr2,ins.type2);fprintf(stdout,"\n");break;
  case SUB:fprintf(stdout,"sub");print_comp(ins.adr1,ins.type1);print_comp(ins.adr2,ins.type2);fprintf(stdout,"\n");break;
  case MOV:fprintf(stdout,"mov");print_comp(ins.adr1,ins.type1);print_comp(ins.adr2,ins.type2);fprintf(stdout,"\n");break;
  case MOD:fprintf(stdout,"mod");print_comp(ins.adr1,ins.type1);print_comp(ins.adr2,ins.type2);fprintf(stdout,"\n");break;
  case ORG:fprintf(stdout,"org");print_comp(ins.adr1,ins.type1);fprintf(stdout,"\n");break;
  case END:fprintf(stdout,"end");fprintf(stdout,"\n");break;
  case INT:fprintf(stdout,"int");print_comp(ins.adr1,ins.type1);fprintf(stdout,"\n");break;
  case JMP:fprintf(stdout,"jmp");print_comp(ins.adr1,ins.type1);fprintf(stdout,"\n");break;
  case JZ:fprintf(stdout,"jz");print_comp(ins.adr1,ins.type1);print_comp(ins.adr2,ins.type2);fprintf(stdout,"\n");break;
  case JNZ:fprintf(stdout,"jnz");print_comp(ins.adr1,ins.type1);print_comp(ins.adr2,ins.type2);fprintf(stdout,"\n");break;
  case JE:fprintf(stdout,"je");print_comp(ins.adr1,ins.type1);print_comp(ins.adr2,ins.type2);fprintf(stdout,"\n");break;
  default:printf("coucou\n");fprintf(stderr,"Erreur interne  labexe\n");exit(0);
 }
fin

void test_comp(entier adr,entier type)
debut
 switch (type)
 {
  case 0:break;
  case 1:break;
  case 2:break;
  default:instr_errone();
 }
fin

void test_instr(instruction ins)
debut
switch (ins.instr)
 {
  case PUSH:test_comp(ins.adr1,ins.type1);break;
  case POP:test_comp(ins.adr1,ins.type1);break;
  case ADD:test_comp(ins.adr1,ins.type1);test_comp(ins.adr2,ins.type2);break;
  case SUB:test_comp(ins.adr1,ins.type1);test_comp(ins.adr2,ins.type2);break;
  case MOV:test_comp(ins.adr1,ins.type1);test_comp(ins.adr2,ins.type2);break;
  case MOD:test_comp(ins.adr1,ins.type1);test_comp(ins.adr2,ins.type2);break;
  case ORG:test_comp(ins.adr1,ins.type1);break;
  case END:break;
  case INT:test_comp(ins.adr1,ins.type1);break;
  case JMP:test_comp(ins.adr1,ins.type1);break;
  case JZ:test_comp(ins.adr1,ins.type1);test_comp(ins.adr2,ins.type2);break;
  case JNZ:test_comp(ins.adr1,ins.type1);test_comp(ins.adr2,ins.type2);break;
  case JE:test_comp(ins.adr1,ins.type1);test_comp(ins.adr2,ins.type2);break;
  default:instr_errone();
 }
fin
