#ifndef OUTILS_ASM_H

#define OUTILS_ASM_H

#include <stdio.h>

/* #################### Gestion des instructions ######################## */


/* **************** Creation des differents type d'instruction *********** */
typedef enum {PUSH,POP,ADD,SUB,MOV,MOD,ORG,END,INT,JMP,JZ,JNZ,JE} typeinstr;

/* ****************Creation du type instruction ************************** */
typedef struct Instruction
 {
  typeinstr instr;
  int adr1; /* adresse de la premiere composante */
  int type1; /* type de la premire composante */
  int adr2; /* adresse de la seconde composante */
  int type2; /* type de la seconde composante */
 } instruction;

/* les types possible sont:
	- 0 normal
	- 1 # valeur direct
	- 2 @ valeur de l'adresse*/

#define max_instr 10000 /* ************ Nombre maximal d'instruction d'un programme */
#define max_case_mem 8000 /* taille de la mmoire */

instruction bloc_instr[max_instr];
instruction make_instr(typeinstr instr,entier adr1,entier type1,entier adr2,entier type2);
void add_instr(typeinstr instr,entier adr1,entier type1,entier adr2,entier type2);
void aff_instr(instruction ins,int i);

void print_comp(entier adr,entier type);
void print_instr(instruction ins);
void test_comp(entier adr,entier type);
void test_instr(instruction ins);

#endif
