#include <stdio.h>
#include "outils.h"
#include "outils_exe.h"
#include "erreur.h"
#include "outils_asm.h"
#include <limits.h>

/* ################### Donne la valeur du premier arguments ################### */
entier donne_valeur_un(instruction ins)
debut
 switch (ins.type1)
  debut
    case 0: si (ins.adr1>=max_case_mem) instr_errone();
            retourne memoire[ins.adr1];
    case 1: retourne ins.adr1;
    case 2: si (ins.adr1>=max_case_mem) instr_errone();
            si (memoire[ins.adr1]>=max_case_mem) 
	         debut
		   fprintf(stderr,"Erreur de segmentation\n");
		   exit(EXIT_FAILURE);
		 fin
            retourne memoire[memoire[ins.adr1]];
    default:fprintf(stderr,"Erreur de composant 1\n");instr_errone();
  fin
fin


/* ################### Donne la valeur du second arguments ################### */
entier donne_valeur_deux(instruction ins)
debut
 switch (ins.type2)
  debut
    case 0: si (ins.adr2>=max_case_mem) instr_errone();
             retourne memoire[ins.adr2];
    case 1: retourne ins.adr2;
    case 2:si (ins.adr2>=max_case_mem) instr_errone();
            si (memoire[ins.adr2]>=max_case_mem) 
	         debut
		   fprintf(stderr,"Erreur de segmentation\n");
		   exit(EXIT_FAILURE);
		 fin
            retourne memoire[memoire[ins.adr2]];
    default:fprintf(stderr,"Erreur de composant 2\n");instr_errone();
  fin
fin

/* ########### lire le fichier et le mettre en mmoire ####################*/ 
instruction *lire_programme(void)
debut
 instruction ins;
 instruction *prog_bis;
 int test;
 nb_instr=0;
 
 /* initialisation de la mmoire du programme */
 prog_bis=(instruction *)malloc(sizeof(instruction));
 Erreur_memoire(prog_bis,"programme","lire_programme");
 
 /* tant qu'on n'a pas atteint la fin de fichier */
 tantque (1)
  debut
    test=fread(&ins,sizeof(instruction),1,file_exe);
    
    /* *** on test la fin de fichier ou une erreur systeme */
    si (!test) 
     debut
       si (feof(file_exe)) break;
       /* si erreur de lecture */
       ferror(file_exe);
       fprintf(stderr,"Erreur de lecture du fichier\n");
       exit(EXIT_FAILURE);
     fin
    
    /* on test la validit de la lecture */
    test_instr(ins);
    
    /* on place l'instruction en mmoire */
    prog_bis[nb_instr]=ins;
    nb_instr++;
    
    /* on agrandit le programme */
    prog_bis=(instruction *)realloc(prog_bis,sizeof(instruction)*(nb_instr+1));
    Erreur_memoire(prog_bis,"programme","lire_programme");
  fin 
 retourne prog_bis;
fin




/* #################### INTERRUPTIONS SYTEME ################################ */
void interruption(entier inter)
debut
  switch (inter)
   debut
     /* lire */ case 1:printf("Lire une valeur:");
                       scanf("%d",&memoire[0]);
		       si (memoire[0]<0)
		        debut
			 fprintf(stderr,"Je ne prend que des nombres >=0,merci\n");
			 exit(0);
			fin
		       break;
     /* ecrire */ case 2:printf("Rsultat %d \n",memoire[1]);break;
     /* ouvregraph */case 3:ouvre_graph();break;
     /* fermegraph */case 4:ferme_graph();break;
     /* efface */case 5:clear_graph();break;
     /* pixel */case 6:placer_point(memoire[1],memoire[2],memoire[3]);break;
     default:fprintf(stderr,"Erreur de INT\n");instr_errone();break;
  fin
fin



/* ####################### Execution d'un add ################################# */
void add(instruction ins)
debut
 int tmp1,tmp2;

 /* on interdit de faire 4:=A+1 */ 
 si (ins.type1==1) instr_errone();
 
 /* On prend les   valeurs */
 tmp2=donne_valeur_deux(ins);
 tmp1=donne_valeur_un(ins);

 /* on effectue l'opration, si on passe en dessous de zero on remet aux max */
 si (ins.type1==0) 
   si (memoire[ins.adr1]+tmp2<0) memoire[ins.adr1]=INT_MAX;
    else memoire[ins.adr1]+=tmp2;
  else 
    si (memoire[memoire[ins.adr1]]+tmp2<0)memoire[memoire[ins.adr1]]=INT_MAX;
     else memoire[memoire[ins.adr1]]+=tmp2;  
fin


/* ####################### Execution d'un sub ################################# */
void sub(instruction ins)
debut
 int tmp1,tmp2;

 /* on interdit de faire 4:=A-1 */  
 si (ins.type1==1) instr_errone();

  /* On prend les valeurs */    
 tmp2=donne_valeur_deux(ins);
 tmp1=donne_valeur_un(ins);

 /* on effectue l'opration, on travail sur des nombre >0 */ 
 si (ins.type1==0) 
  debut
   memoire[ins.adr1]-=tmp2;
   si (memoire[ins.adr1]<0) memoire[ins.adr1]=0;
  fin
  else 
   debut
    memoire[memoire[ins.adr1]]-=tmp2;
    si (memoire[memoire[ins.adr1]]<0) memoire[memoire[ins.adr1]]=0;
   fin
fin


/* ####################### Execution d'un mov ################################# */
void mov(instruction ins)
debut
 int tmp1,tmp2;

 /* on interdit de faire 4:=A */   
 si (ins.type1==1) instr_errone();

  /* On prend les valeurs */        
 tmp2=donne_valeur_deux(ins);
 tmp1=donne_valeur_un(ins);

 /* on effectue l'opration */  
 si (ins.type1==0) memoire[ins.adr1]=tmp2;
  else memoire[memoire[ins.adr1]]=tmp2;
fin


/* ####################### Execution d'un mod ################################# */
void mod(instruction ins)
debut
 int tmp1,tmp2;

 /* on interdit de faire 4:=A mod 6 */    
 si (ins.type1==1) instr_errone();

  /* On prend les valeurs */
 tmp2=donne_valeur_deux(ins);
 tmp1=donne_valeur_un(ins);
 
 /* on effectue l'opration */   
 si (ins.type1==0) memoire[ins.adr1]=memoire[ins.adr1] % tmp2;
  else memoire[memoire[ins.adr1]]=memoire[ins.adr1] % tmp2;
fin


/* ####################### Execution d'un jz ################################# */
int jz(instruction ins)
debut
 int tmp1,tmp2;
 
   /* On prend les valeurs */
 tmp2=donne_valeur_deux(ins);
 tmp1=donne_valeur_un(ins);
 
 /* on effectue oui ou non le changement d'adresse */
 si (tmp1==0)
   si (ins.type2==1) retourne ins.adr2;
     else retourne memoire[ins.adr2];
  else retourne pointeur+1;

  fprintf(stderr,"erreur de jz la");
  exit(EXIT_FAILURE);
fin


/* ####################### Execution d'un jnz ################################# */
int jnz(instruction ins)
debut
 int tmp1,tmp2;

   /* On prend les valeurs */ 
 tmp2=donne_valeur_deux(ins);
 tmp1=donne_valeur_un(ins);

 /* on effectue oui ou non le changement d'adresse */ 
 si (tmp1!=0)
   si (ins.type2==1) retourne ins.adr2;
     else retourne memoire[ins.adr2];
  else retourne pointeur+1;

  fprintf(stderr,"erreur de jnz");
  exit(EXIT_FAILURE);
fin

/* ####################### Execution d'un je ################################# */
void je(instruction ins)
debut
 int tmp1,tmp2;
 
   /* On prend les valeurs */ 
 tmp2=donne_valeur_deux(ins);
 tmp1=donne_valeur_un(ins);

 /* on effectue oui ou non le changement de memoire */  
 si (tmp1==tmp2) memoire[ins.adr1]=0;
fin
