#include <stdio.h>
#include "table.h"
#include "outils.h"
#include "var.h"
#include "generateur.h"
#include "outils_asm.h"
#include <string.h>



/*##############################################################################
####################### GESTION DE LA TABLE DES SYMBOLES #######################
################################################################################ */


/* Interne: ajout une fonction prdfinies dans la tables des symboles 
            avec son nom et son nombre d'arguments ******************* */
void ajout(int cb,char *nom,int nb_par)
debut
 strcpy(table[cb].nom_fun,nom);
 table[cb].nb_param=nb_par;
 table[cb].nb_var=0;
 table[cb].nb_tab=0;
 nb_fun_lu++; /* on augmente le nombre de fonction lu */
fin

/* ####################### initialisation de la table des symboles ############# */
void init_table(void)
debut
 int i,j;
 ligne=1;
 taille=0;
 nb_cases_prises=4; /* Ax, Bx, Cx, Dx */
 nb_fun_lu=0;
 ds_quoi=6;
 nb_parametre=0;
 nb_var_global=0;
 nb_tab_global=0;
 ligne_asm=1;
 nb_boucle=0;
 prog_ou_non=faux;
 commentaire=faux;  
 nb_instr=0;
 
 /* ajout des fonctions prdfinie */
 
 ajout(0,"lire",0);ajout(1,"ecrire",1);ajout(2,"ouvregraph",0);
 ajout(3,"fermegraph",0);ajout(4,"efface",0);ajout(5,"pixel",3);
 ajout(6,"retourner",1);ajout(7,"sortir",1);ajout(8,"enfoncer",0);
 ajout(9,"quitter",0);
 
  /* ********* IL faudra peut etre mettre la mmoire  zero  
   mais la je ne le fait pas pour gagner en vitesse
  ****** */
 
/* pour(j=nb_fun_lu;j<max_fun;j++)
  debut
    strcpy(table[j].nom_fun,"");
    table[j].adresse=0;
    table[j].nb_var=0;
    table[j].nb_tab=0;
    pour(i=0;i<max_var;i++) 
     debut
      strcpy(table[j].table_var[i].nom_var,"");
      table[j].table_var[i].adresse=0;
     fin
    pour(i=0;i<max_tab;i++) 
     debut
      strcpy(table[j].table_tab[i].nom_tab,"");
      table[j].table_tab[i].taille=0;
      table[j].table_tab[i].adresse=0;
     fin
   table[j].nb_param=0;
   pour(i=0;i<max_param;i++)
    debut
      table[j].table_param[i].adresse=0;
      table[j].table_param[i].type=0;
      strcpy(table[j].table_param[i].nom_param,"");
    fin
  fin */
fin



/* ################## recherche d'un case mmoire libre ######################## */
int cherche_case(void)
debut
 
/* ******* Si on a atteint le maximal, on stoppe *********** */
 si (nb_cases_prises==max_case_mem) 
  debut
   fprintf(stderr,"Trop d'objet crer, plus de place en mmoire\n");
   retourne -1;
  fin

/* ************ On augmente les variables temporaires de l'hyperboucle ******** */
 si (nb_hyper!=0)
  debut
    pile_hyper[nb_hyper-1].adr_env[pile_hyper[nb_hyper-1].nb_tmp]=nb_cases_prises;
    pile_hyper[nb_hyper-1].nb_tmp++;
  fin
 
 /* ********** on augmente le nombre de case prise ************* */
 nb_cases_prises++;
 retourne (nb_cases_prises-1);
fin




/* ##################### On change de fonction ############################ */
void change_fun()
debut
 int i;
 
/* ******************* Si on a atteint le nombre maximal de fonctions ********* */ 
  si (nb_fun_lu==max_fun)
   debut
     erreur_ligne();
     fprintf(stderr,"Trop de fonctions demandes :%s, plus de mmoire\n",nom_fun_en_cours);
     exit(0);
   fin
   
/************** on test si la fonction n'a pas dj t dfinies ******** */
  pour(i=0;i<nb_fun_lu;i++)
    si (strcmp(table[i].nom_fun,nom_fun_en_cours)==0)
     debut
      erreur_ligne();
      fprintf(stderr,"Fonction dj dfinies ailleurs\n");
      exit(0);
     fin

/* ************** On change de nom de fonction courante ************* */
  strcpy(table[nb_fun_lu].nom_fun,nom_fun_en_cours);

/* ************* On met a jours l'adresse de depart de la fonction ******** */
  table[nb_fun_lu].adresse=ligne_asm;

/* ************ On augmente le nombre de fonction lu ******************* */
  nb_fun_lu++;
fin



/* ####################### Quand on atteint le programme principal,
         on fait comme pour un changement de fonction
	 on met dans la able des symboles  ######################## */
void mettre_programme(void)
debut
 int i;
/* ******************* Si on a atteint le nombre maximal de fonctions ********* */ 
  si (nb_fun_lu==max_fun)
   debut
     erreur_ligne();
     fprintf(stderr,"Plus de mmoire pour le programme principal\n");
     exit(0);
   fin

  strcpy(table[nb_fun_lu].nom_fun,"programme");
  table[nb_fun_lu].adresse=ligne_asm;
  nb_fun_lu++;
  
  /* ********* On initialise les tableaux globaux *********** */
  for(i=0;i<nb_var_global;i++)
   debut
     add_instr(MOV,table_tab_global[i].adresse+1,0,table_tab_global[i].taille+1,1);
     add_instr(MOV,table_tab_global[i].adresse,0,table_tab_global[i].adresse+2,1);
   fin
  
/* ************ Mais en plus on indique que maintenant on est dans le programme principal */
  prog_ou_non=vrai;
fin




/* ##################### test si le nom de l'objet est dj dans les parametre 
                           de definition de la fonction ##################### */
bool deja_parametre(int j,char *name)
debut
 int i;
 /* ********** On parcours la table des parametre pour voir si on trouve *** */
 pour(i=0;i<table[j].nb_param;i++) 
   si (strcmp(table[j].table_param[i].nom_param,name)==0) retourne vrai;
retourne faux;
fin




/* ##################### test si le nom de l'objet est dj dans les variables globales #### */
bool deja_var_global(char *name)
debut
 int i; 
 /* **********  on parcours le tableaux des variables globales  ***************** */
 pour(i=0;i<nb_var_global;i++)
  si (strcmp(name,table_var_global[i].nom_var)==0) retourne vrai;
 retourne faux;
fin




/* ##################### test si le nom de l'objet est dj dans les tableaux globales #### */
bool deja_tab_global(char *name)
debut
 int i;
 /* **********  on parcours le tableaux des tableaux globales  ***************** */
 pour(i=0;i<nb_tab_global;i++)
  si (strcmp(name,table_tab_global[i].nom_tab)==0) retourne vrai;
 retourne faux;
fin



/* ################## Fonction de cration d'une variable ####################
  -> on regarde si la variables n'a pas dj t cres
  -> on regarde si elle n'est pas dans les parametres
  -> on regarde si elle n'est pas dj dans les globales
    sinon
      - mettre dans la tables des symboles
      - allocation d'une case mmoire
      - instruction de mise  zro
 ############################################################################# */
int creation_var(char *name_var,char *name_fun)
debut
 int i,j,x;
 bool test;
  j=nb_fun_lu-1;

        /* **************** La variable est elle dj en parametre ************/ 
          test=deja_parametre(j,name_var);
	    si (test==vrai)
	     debut
	      erreur_ligne();
	      fprintf(stderr,"Variable dj en parametre:%s\n",name_var);
	      exit(0);
	     fin
	     
	  /* ************* La variable est elle dj une global ? ******** */    
	   /* test=deja_var_global(name_var);
	    si (test==vrai)
	     debut
	      erreur_ligne();
	      fprintf(stderr,"Variable dj en variable global:%s\n",name_var);
	      exit(0);
	     fin */

/* **************** On parcours dans la table de la fonction *********** */
	pour(i=0;i<max_var;i++)
	 debut
	 
	    /* ************* Si nom dj prsent alors erreur ******* */
	    si (strcmp(table[j].table_var[i].nom_var,name_var)==0)
	     debut
	      erreur_ligne();
	      fprintf(stderr,"Variable dj dfinie: %s\n",name_var);
	      exit(0);
	     fin
	     
	    /* ********* ds qu'on trouve une case libre, on peut crer la var */
	    si (strcmp(table[j].table_var[i].nom_var,"")==0)
	     debut
	     
	     /* ********** recherche d'une case mmoire ********* */
	      x=cherche_case();
	      si (x==-1)
	       debut
	        erreur_ligne();
		fprintf(stderr,"Pas assez de mmoire pour la variable:%s\n",name_var);
		exit(0);
	       fin
	       
	     /* ************ instruction de mise  zero ************ */
	      add_instr(MOV,x,0,0,1);
	     
	     /* **************** Copie dans la table des symboles ******* */
              strcpy(table[j].table_var[i].nom_var,name_var);
	      table[j].table_var[i].adresse=x;
	      table[j].nb_var++;
              retourne x;
            fin   
         fin
	 
	 
	erreur_ligne();
	fprintf(stderr,"Trop de variable dfinies dans la fonction:%s pour %s\n",name_fun,name_var);
        exit(0);
fin



/* ######################## Cration d'une variable global ##################### */
int creation_var_global(char *name_var)
debut
 int x;
 bool test;

/* Si on a atteint le nombre maximal de variables ********** */ 
 si (nb_var_global==max_var)
  debut
   erreur_ligne();
   fprintf(stderr,"Vous demander trop de creation de variable\n");
   exit(0);
  fin
  
/* On test si on ne la pas dj dfinies ***************** */
 test=deja_var_global(name_var);
  si (test==vrai)
   debut
     erreur_ligne();
     fprintf(stderr,"Variable dj en variable global:%s\n",name_var);
     exit(0);
  fin  

/* *********** On lui rserve une place en mmoire ************ */
  x=cherche_case();
   si (x==-1)
    debut
     erreur_ligne();
     fprintf(stderr,"Pas assez de mmoire pour la variable:%s\n",name_var);
     exit(0);
    fin

/* ********* ajout dans la table des symboles ************ */
  table_var_global[nb_var_global].adresse=x;
  strcpy(table_var_global[nb_var_global].nom_var,name_var);
  nb_var_global++;

/* la mmoire tant initialiser  zro, les globales aussi, donc c'est bon */
fin



/* ################ Cration d'un parametre d'une fonction ################
                         lors des dfinitions
  -> on interdit le passage de global
  -> on empeche le duplicatat
  -> on alloue de la mmoire
  -> on met dans la table des symboles
du genre entier fun(A,B,Tab,etc...)
*/
int parametre_var(char *name_var,char *name_fun,int type)
debut
 int i,j,x,y;
 bool test;
 j=nb_fun_lu-1;

/* *************** Interdit la passage de global *************** */
 test=deja_var_global(name_var);
 si (test==vrai)
  debut
   erreur_ligne();
   fprintf(stderr,"Parametre dj en global:%s\n",name_var);
   exit(0);
 fin

/**********  On parcours la table des symboles associ  la fonctions ********** */
   pour(i=0;i<max_param;i++)
    debut
	
	/* ************* Dja dfinies ? si oui alors erreur ************* */
	si (strcmp(table[j].table_param[i].nom_param,name_var)==0)
	     debut
	      erreur_ligne();
	      fprintf(stderr,"Parametre dj dfini: %s\n",name_var);
	      exit(0);
	      fin
	
	/* ************ Ds qu'on trouve une place libre on peut crer ******** */
        si (strcmp(table[j].table_param[i].nom_param,"")==0)
	  debut 
	  
	  /* ********* Si c'est une variable **************** */
	     si (type==0)
	      debut
	      
	        /* ******* recherche d'une case mmoire ********* */
	        x=cherche_case();
	        si (x==-1)
	         debut
	           erreur_ligne();
		   fprintf(stderr,"Pas assez de mmoire pour le paramtre:%s\n",name_var);
		   exit(0);
	         fin
		
		/* ********** on ajoute dans la table des symboles ********** */
                strcpy(table[j].table_param[i].nom_param,name_var);
	        table[j].table_param[i].adresse=x;
	        table[j].table_param[i].type=0;
	        table[j].nb_param++;
                retourne x;
             fin
	     
	    /* ********* Sinon c'est un tableaux ********* */
	    /* ********** recherche d'une case mmoire d'adresses ******** */
	     x=cherche_case();
	     si (x==-1)
	         debut
	           erreur_ligne();
		   fprintf(stderr,"Pas assez de mmoire pour le paramtre:%s\n",name_var);
		   exit(0);
	         fin
	     
	     /* *********** recherche d'une case mmoire de taille ********** */
	     /* Elle sera remplie ultrieument */
	     y=cherche_case();
	     si (y==-1)
	         debut
	           erreur_ligne();
		   fprintf(stderr,"Pas assez de mmoire pour le paramtre:%s\n",name_var);
		   exit(0);
	         fin
	     
	     /* ***************** mise  jours de la table des symboles ******** */
	     strcpy(table[j].table_param[i].nom_param,name_var);
	     table[j].table_param[i].adresse=x;
	     table[j].table_param[i].type=1;
	     table[j].nb_param++;
	     retourne x;
        fin
     fin
     
   /* ************* Sinon erreur ************ */
  erreur_ligne();
  fprintf(stderr,"Trop de variables dfinies dans la fonction:%s pour %s\n",name_fun,name_var);
  exit(0);
fin



/* ################### donne l'adresse d'une variable dans une fonction  ####################*/
int cherche_adresse_var(char *name_var,char *name_fun)
debut
 int i,j,x;
  j=nb_fun_lu-1;
      
      /* **************** on parcours les variables de cration *********** */
      pour(i=0;i<max_var;i++) 
        si (strcmp(table[j].table_var[i].nom_var,name_var)==0) retourne table[j].table_var[i].adresse;

      /* **************** on parcours les parametres ************** */
      pour(i=0;i<table[j].nb_param;i++)
       si (strcmp(table[j].table_param[i].nom_param,name_var)==0) retourne table[j].table_param[i].adresse;

      /* *********** on parcours la tables des globales ************ */
      pour(i=0;i<nb_var_global;i++)
       si (strcmp(name_var,table_var_global[i].nom_var)==0) retourne table_var_global[i].adresse;


      /* ********* Sinon, variables inconnues ************ */
      erreur_ligne();
      fprintf(stderr,"variable inconnue: %s\n",name_var);
      exit(0);
fin


/* *************** Allocation de case mmoire pour un tableau *********** */
int allouer_tab(int tai)
debut
 int i,j,x;
 pour(i=0;i<tai;i++) 
  debut
   x=cherche_case();
   if (x==-1) retourne -1;
  fin
 retourne x;
fin


/* ################### Cration d'un Tableau, idem que variable 
 		a quelques nuances pret ####################################### */
int creation_tab(char *name_tab,char *name_fun,int taille)
debut
 int   i,j,x,y,k,test2;
 bool  test;
  j=nb_fun_lu-1;
  
       /************* Dej en parametre ***************** */
	 test=deja_parametre(j,name_tab);
	    si (test==vrai)
	     debut
	      erreur_ligne();
	      fprintf(stderr,"Tableau dj en parametre:%s\n",name_tab);
	      exit(0);
	     fin
	
	/* *************** Ou en global **********************/ 
	/*    test=deja_tab_global(name_tab);
	    si (test==vrai)
	     debut
	      erreur_ligne();
	      fprintf(stderr,"Tableau dj en global:%s\n",name_tab);
	      exit(0);
	     fin */
	
	/* **********Parcours de la table des symboles ************* */	   
	pour(i=0;i<max_tab;i++)
	 debut
	 
	     /* *********** Si dj prsents alors erreur ********* */   
	    si (strcmp(table[j].table_tab[i].nom_tab,name_tab)==0)
	     debut
	      erreur_ligne();
	      fprintf(stderr,"Tableau dj dfinie: %s\n",name_tab);
	      exit(0);
	     fin
	     
	    /* ******** Sinon, on peut crer ************ */
	    si (strcmp(table[j].table_tab[i].nom_tab,"")==0)
	     debut 
	     
	     /* ******** recherche d'une case mmoire pour l'adresse ******** */
	      x=cherche_case();
	      si (x==-1)
	       debut
	        erreur_ligne();
		fprintf(stderr,"Pas assez de mmoire pour le tableau:%s\n",name_tab);
		exit(0);
	       fin
	    
	     /* ********* recherche d'une case mmoire pour la taille ********* */
	      y=cherche_case();
	      si (y==-1)
	       debut
	        erreur_ligne();
		fprintf(stderr,"Pas assez de mmoire pour le tableau:%s\n",name_tab);
		exit(0);
	       fin
	    
	      /* ************* on alloue l'espace mmoire ncessaire ******** */
	      test2=allouer_tab(taille+1);
	      if (test2==-1)
	       debut
	         erreur_ligne();
		 fprintf(stderr,"Plus assez de mmoire pour le tableau:%s\n",name_tab);
		 exit(0);
	       fin
	       
	      /* Instruction de pour savoir ou est la taille et l'adresse */
	      add_instr(MOV,y,0,taille+1,1);
	      add_instr(MOV,x,0,x+2,1);
	      /* les tableaux ne sont pas mis  zero au dpart */
	      /* pour(k=0;k<=taille;k++)
	       debut
	        add_instr(MOV,x+2+k,0,0,1);
	       fin */
	       
	      /* mise  jours de la table des symboles */
              strcpy(table[j].table_tab[i].nom_tab,name_tab);
	      table[j].table_tab[i].adresse=x;
	      table[j].table_tab[i].taille=taille;
              retourne x;
            fin    
         fin
	 
	/* Sinon erreur */
	erreur_ligne();
	fprintf(stderr,"Trop de Tableaux dfinis dans la fonction:%s pour %s\n",name_fun,name_tab);
        exit(0);
fin



/* ###################### Cration d'un tableau global ################### */
int creation_tab_global(char *name_tab,int taille)
debut
 int x,y,test2;
 bool test;
 
 /* ********** Si on en demande trop *********** */
 si (nb_tab_global==max_tab)
  debut
   erreur_ligne();
   fprintf(stderr,"Vous demander trop de creation de tableaux\n");
   exit(0);
  fin
  
 /* ************ Si on la dj fait ************ */
 test=deja_tab_global(name_tab);
 si (test==vrai)
  debut
    erreur_ligne();
    fprintf(stderr,"Tableau dj en global:%s\n",name_tab);
    exit(0);
  fin
  
 /* ************ recherche d'une case mmoire pour l'adresse *********** */
 x=cherche_case();
 si (x==-1)
  debut
   erreur_ligne();
   fprintf(stderr,"Pas assez de mmoire pour le tableau:%s\n",name_tab);
   exit(0);
  fin
  
 /* ************** recherche d'une case mmoire pour la taille *********** */
 y=cherche_case();
 si (y==-1)
  debut
   erreur_ligne();
   fprintf(stderr,"Pas assez de mmoire pour le tableau:%s\n",name_tab);
   exit(0);
  fin
  
 
 /* *************** Allocation de la mmoire pour la tableaux *********** */
 test2=allouer_tab(taille+1);
 if (test2==-1)
  debut
   erreur_ligne();
   fprintf(stderr,"Plus assez de mmoire pour le tableau:%s\n",name_tab);
   exit(0);
  fin
  
 /* ************** mise  jours de la tables des symboles **************** */
 table_tab_global[nb_tab_global].adresse=x; 
 table_tab_global[nb_tab_global].taille=y;
 strcpy(table_tab_global[nb_tab_global].nom_tab,name_tab);
 nb_tab_global++; 
fin



/* ######################## Recherche d'une adresse d'un tableau ##############
       ressemble beaucoup  celle pour les variables */
int cherche_adresse_tab(char *name_tab,char *name_fun)
debut
 int i,j,x;

  j=nb_fun_lu-1;

    /* ****************** recherche dans les cres **************** */
      pour(i=0;i<max_tab;i++) 
        si (strcmp(table[j].table_tab[i].nom_tab,name_tab)==0) 
	 debut
	  taille=table[j].table_tab[i].taille;
	  retourne table[j].table_tab[i].adresse;
	 fin
  
      /* ***************** recherche dans les paramtres *********** */    
      pour(i=0;i<table[j].nb_param;i++)
       si (strcmp(table[j].table_param[i].nom_param,name_tab)==0) retourne table[j].table_param[i].adresse;
      

      /* ************ recherche dans les globales ************ */   
      pour(i=0;i<nb_tab_global;i++)
       si (strcmp(table_tab_global[i].nom_tab,name_tab)==0) retourne table_tab_global[i].adresse;

      /* *************** Sinon erreur ******************** */
      erreur_ligne();
      fprintf(stderr,"Tableau inconnu: %s\n",name_tab);
      exit(0);
fin


/* ############################ Ajout en parametre d'un objet ############### 
					dans le corp d'une fonctions      
du genre A:=fun(B,V,E,Tab);
*/
int ajoute_en_param(char *name,char *nom_fun,int type)
debut
 int ou;
 bool test;
 
 /* ******** Si on demande trop de parametres ************* */
 si (nb_parametre==max_param)
  debut
   erreur_ligne();
   fprintf(stderr,"Trop de parametres demande\n");
   exit(0);
  fin
 

 /* ********** on Met dans la tables des paramtres 
           -> le type
	   -> le nom
	   -> l'adresse *********** */
 parametre_en_cour[nb_parametre].type=type;
 strcpy(parametre_en_cour[nb_parametre].nom_param,name);
 si (type==0)
   parametre_en_cour[nb_parametre].adresse=cherche_adresse_var(name,nom_fun_en_cours);
 else
  parametre_en_cour[nb_parametre].adresse=cherche_adresse_tab(name,nom_fun_en_cours);
 nb_parametre++;
fin
