#include "outils.h"
#include "gene_tools.h"
#include "var.h"
#include "table.h"
#include "outils_asm.h"

/*##############################################################################
########################### Outils pour la gnration de code ##################
################################################################################*/


/* ############################# Push toute les variables donne en parametre
				  A:=fun(X,Y,Z) => PUSH X, PUSH Y, PUSH Z #### */
void pusher(void)
debut
 int j;
 
 /* ******************* Pour tous les parametres ***************** */
 pour(j=0;j<nb_parametre;j++)
  debut
   
   /* ***************** Si c'est une variable, on push ************** */
   si (parametre_en_cour[j].type==0) 
    debut
     add_instr(PUSH,parametre_en_cour[j].adresse,0,0,0);/* fprintf(stdout,"push %d\n",parametre_en_cour[j].adresse); */
    fin
   
    else /* ***************** C'est un tableau *************** */
     debut
       /* *************** On push l'adresse de dbut de donnees ************* */
       add_instr(PUSH,parametre_en_cour[j].adresse,0,0,0);
       
       /* *************** On push la taille du tableau ********************** */
       add_instr(PUSH,parametre_en_cour[j].adresse+1,0,0,0);
       /*fprintf(stdout,"push %d\npush %d\n",parametre_en_cour[j].adresse,parametre_en_cour[j].adresse+1); */
     fin
  fin
fin

/* ################# Fonction interne qui dtermine le nombre de push 
		      qu'il faudra pour une fonction ########################## */
int combien_de_push(void)
debut
 int j,cb;
 cb=0;
 pour(j=0;j<nb_parametre;j++)
  debut
   si (parametre_en_cour[j].type==0) cb++; /* une variable <=> un push */
    else cb+=2;                            /* un tableaux <=>  deux push */
  fin
 retourne cb;
fin


/* ########################### Recherche d'indice d'une fonction dans 
				la table des symboles ######################### */
int recherche_fonction(char *name)
debut
 int j;
 
 /* On parcours toutes la tables */
 pour(j=0;j<max_fun;j++)
  debut
   /* Si on trouve, on retourne l'indice */
   si (strcmp(table[j].nom_fun,name)==0) retourne j;
   
   /* Si on trouve du vide on s'arrete, car la fonction n'existe pas */
   si (strcmp(table[j].nom_fun,"")==0)
    debut
     erreur_ligne();
     fprintf(stderr,"Fonction inconnues:%s\n",name);
     exit(0);
    fin
  fin
 
 /* ********* Si la table a ete parcourue entirement, sans rien trouve alors erreur */
 erreur_ligne();
 fprintf(stderr,"Fonction inconnues:%s\n",name);
 exit(0);
fin


/* ##################### Test la validit des arguments #######################*/
bool bon_argument(int adr) /* adr,  indice de la fonction dans la table des symboles */
debut
 int j;
 
 /* ************** On regarde dj si le nombre de parametres est bon ********** */
 si (nb_parametre!=table[adr].nb_param) retourne faux;

 /* Pour tout les arguments */
 pour(j=0;j<nb_parametre;j++)
 
  /* si le type n'est pas bon, on quitte */
  si (table[adr].table_param[j].type!=parametre_en_cour[j].type) 
   debut
     erreur_ligne();
     fprintf(stderr,"Le %d arguments n'est pas du bon type\n",j+1);
     exit(0);
   fin
 retourne vrai;
fin
